#include "playlist.h"

#include <qmime.h>
#include <qstrlist.h>
#include <qstringlist.h>
#include <qdir.h>
#include <qtextstream.h>
#include <qfile.h>

PlaylistView::PlaylistView( QWidget *parent, const char *name, bool sdo )
    : QListView( parent, name ), lastItem( NULL )
{
    addColumn( tr("Name") );
    setTreeStepSize( 20 );
    setSorting(-1);
    setAllColumnsShowFocus( TRUE );
}

void PlaylistView::savePlaylist( const QString &name )
{
    qDebug(name);
    QString list;

    f.setName(name);
    f.open(IO_WriteOnly | IO_Truncate);
    if (f.isOpen()) {
	QListViewItemIterator it(this);
	for( ; it.current() ; it++)
	    list += it.current()->text(0)+"\n";
	f.writeBlock(list, list.length());
    }
    f.close();
}

void PlaylistView::loadPlaylist( const QString &name )
{
    qDebug(name);
}

void PlaylistView::addToPlaylist( const QString &name )
{
    qDebug(name);
    QListViewItem *currItem = new QListViewItem(this, name);
    if (lastItem) currItem->moveItem(lastItem);
    lastItem = currItem;
}

void PlaylistView::removeFromPlaylist( void )
{
    QListViewItem *pls = selectedItem ();
    if (pls) takeItem(pls);
}
